/*
 * BorrowerSpecializationGUI.java
 *
 * Created on 19. september 2007, 08:58
 */

package library2007;
import javax.swing.JOptionPane;
/**
 *
 * @author  admin
 */
public class BorrowerSpecialisationGUI extends javax.swing.JFrame {
    
    /** Creates new form BorrowerSpecializationGUI */
 public BorrowerSpecialisationGUI() {
        initComponents();
        borrowerCol = new BorrowerCollection();
    }
    
     
    Borrower b;
    BorrowerCollection borrowerCol;
    
   private void showNumbers() {
        int num = borrowerCol.numberOfBorrowers();
        String numStr = new Integer(num).toString();
        numberTextField.setText(numStr);
    }
   /** Ass. 2e & 2g Create a borrower and add to collection */
    private void createBorrower() {
        
        dataArea.setText("");
                   
        String cprNo = JOptionPane.showInputDialog("State cprNo of borrower: ");
        String name = JOptionPane.showInputDialog("State name of borrower: ");       
                      
        String yearStr = JOptionPane.showInputDialog("State year of registration: ");
        int year = Integer.parseInt(yearStr);
                
        //String bType = JOptionPane.showInputDialog("Type of borrower:\n"+"Adult", "Normal");
        Object[] possibleValues = { "Adult", "Child"};
        String  bType = (String) JOptionPane.showInputDialog(null, "Choose Borrower Type", "Input",
                                                JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[0]);     
        
        if (bType.equals("Adult")) {
            String address = JOptionPane.showInputDialog("State address of borrower: ");
            String phoneStr = JOptionPane.showInputDialog("State phoneNo of borrower: "); 
            int phoneNo = Integer.parseInt(phoneStr);
            b = new AdultBorrower(cprNo, name, bType, year, address, phoneNo);
        }
        else if (bType.equals("Child")) {
            String parentCprNo = JOptionPane.showInputDialog("State cprNo of parent: ");            
            AdultBorrower parent = (AdultBorrower) borrowerCol.getBorrower(parentCprNo);  
            
            System.out.println(parent.toString());
            
            Object[] possibleValues1 = { "Male", "Female"};
            String  sex = (String) JOptionPane.showInputDialog(null, "Choose Child Sex", "Input",
                                                JOptionPane.QUESTION_MESSAGE, null, possibleValues1, possibleValues[0]);     
            //String sex = JOptionPane.showInputDialog("State sex of child: ");
            b = new ChildBorrower(cprNo, name, bType, year, sex, parent);
        }
        else {
            //Alternatively
            //borrowerCol.createBorrower(cprNo, name, bType,  year);
            b = new Borrower(cprNo, name, bType, year);
        }    
        
        if ( b != null ) {
            borrowerCol.addBorrower(b);
            showBorrower();}
        else
            dataArea.setText("No position found");
        
        showNumbers();
    }

    
    /**Ass. 2e Show last handled borrower */
    private void showBorrower() {
        dataArea.append(b.toString());
        dataArea.append(printEmptyLines(2));
    }
    
    /**Ass. 2e Show all borrowers */
    private void showAllBorrowers() {
        allDataArea.setText(borrowerCol.toString());
    }
    
    /**Ass. 2f Search for a borrower and present search result */
   private void findBorrower() {

        dataArea.setText("");
        
        Object[] possibleValues = { "Index", "CprNo"};
        String  searchStr = (String) JOptionPane.showInputDialog(null, "Choose Search Type", "Input",
                                                JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[0]);     
        b = null;
        if (searchStr.equals("CprNo") ){
            String cprNo = JOptionPane.showInputDialog("State cprNo of borrower: ");          
            b = borrowerCol.getBorrower(cprNo);
        }
        else
        if ( searchStr.equals("Index") ){
            String indexStr = JOptionPane.showInputDialog("State index of borrower: ");    
            int index = Integer.parseInt(indexStr);
            b = borrowerCol.getBorrower(index);
        }
        if ( b != null )
            showBorrower();
        else
            dataArea.setText("No borrower found");    
    }

    /**Ass. 2f Remove for a borrower and present the removed borrower */
    private void removeBorrower() {
        
        dataArea.setText("");
        
        Object[] possibleValues = { "Index", "CprNo"};
        String  searchStr = (String) JOptionPane.showInputDialog(null, "Choose Search Type", "Input",
        JOptionPane.QUESTION_MESSAGE, null, possibleValues, possibleValues[0]);
        b = null;
        if (searchStr.equals("CprNo") ){
            String cprNo = JOptionPane.showInputDialog("State cprNo of borrower: ");
            b = borrowerCol.removeBorrower(cprNo);
        }
        else
            if ( searchStr.equals("Index") ){
                String indexStr = JOptionPane.showInputDialog("State index of borrower: ");
                int index = Integer.parseInt(indexStr);
                b = borrowerCol.removeBorrower(index);
            }
        
        if ( b != null )
            showBorrower();
        else
            dataArea.setText("No borrower found");
        
        showNumbers();
    }
       /**Ass. 2h Read in name, find and show all borrowers by this name */
    
    private String printEmptyLines(int noLines) {
        String s = "";
        for (int i = 0; i < noLines; i++)
            s = s +  "\n";
            return s;
     }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel2 = new javax.swing.JPanel();
        createButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        dataArea = new javax.swing.JTextArea();
        showButton = new javax.swing.JButton();
        dataLabel = new javax.swing.JLabel();
        showAllButton = new javax.swing.JButton();
        dataAllLabel = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        allDataArea = new javax.swing.JTextArea();
        noLabel = new javax.swing.JLabel();
        numberTextField = new javax.swing.JTextField();
        searchButton = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();
        editButton = new javax.swing.JButton();

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        createButton.setText("Create Borrower");
        createButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createButtonActionPerformed(evt);
            }
        });

        jPanel2.add(createButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 70, 180, -1));

        jScrollPane1.setViewportView(dataArea);

        jPanel2.add(jScrollPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(410, 100, 330, 140));

        showButton.setText("Show Borrower");
        showButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showButtonActionPerformed(evt);
            }
        });

        jPanel2.add(showButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 120, 180, -1));

        dataLabel.setFont(new java.awt.Font("MS Sans Serif", 0, 14));
        dataLabel.setText("Borrower Data");
        jPanel2.add(dataLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(420, 55, 210, 30));

        showAllButton.setText("Show All Borrowers");
        showAllButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                showAllButtonActionPerformed(evt);
            }
        });

        jPanel2.add(showAllButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 420, 160, -1));

        dataAllLabel.setFont(new java.awt.Font("MS Sans Serif", 0, 14));
        dataAllLabel.setText("All Borrowers Data");
        jPanel2.add(dataAllLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(420, 300, 120, -1));

        jScrollPane2.setViewportView(allDataArea);

        jPanel2.add(jScrollPane2, new org.netbeans.lib.awtextra.AbsoluteConstraints(420, 340, 320, 220));

        noLabel.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        noLabel.setText("Total number");
        jPanel2.add(noLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(300, 340, 90, 20));

        jPanel2.add(numberTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(300, 380, 70, -1));

        searchButton.setText("Search Borrower");
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        jPanel2.add(searchButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 170, 180, -1));

        deleteButton.setText("Delete Borrower");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        jPanel2.add(deleteButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 230, 180, -1));

        editButton.setText("Edit Borrower");
        editButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editButtonActionPerformed(evt);
            }
        });

        jPanel2.add(editButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 280, 180, -1));

        getContentPane().add(jPanel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, -1, -1));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void editButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editButtonActionPerformed
// TODO add your handling code here:
        // editBorrower();
    }//GEN-LAST:event_editButtonActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
// TODO add your handling code here:
        removeBorrower();
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
// TODO add your handling code here:
        findBorrower();
    }//GEN-LAST:event_searchButtonActionPerformed

    private void showAllButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showAllButtonActionPerformed
// TODO add your handling code here:
        showAllBorrowers();
    }//GEN-LAST:event_showAllButtonActionPerformed

    private void showButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_showButtonActionPerformed
// TODO add your handling code here:
        showBorrower();
    }//GEN-LAST:event_showButtonActionPerformed

    private void createButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createButtonActionPerformed
// TODO add your handling code here:
        createBorrower();
    }//GEN-LAST:event_createButtonActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new BorrowerSpecialisationGUI().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea allDataArea;
    private javax.swing.JButton createButton;
    private javax.swing.JLabel dataAllLabel;
    private javax.swing.JTextArea dataArea;
    private javax.swing.JLabel dataLabel;
    private javax.swing.JButton deleteButton;
    private javax.swing.JButton editButton;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel noLabel;
    private javax.swing.JTextField numberTextField;
    private javax.swing.JButton searchButton;
    private javax.swing.JButton showAllButton;
    private javax.swing.JButton showButton;
    // End of variables declaration//GEN-END:variables
    
}
