/**ChildBorrower.java

 * Author Michael Claudius, Roskilde Computer Science College
 * Version 1.2. 2006.05.23
 * Copyright 2003 by Michael Claudius
 * All rights reserved ?
*/

package library2007;
import java.io.*;

public class ChildBorrower extends Borrower implements Serializable {
	private Borrower parent;
        private String sex;

// constructors for creating objects
        ChildBorrower() {
            super();
        };
    

        ChildBorrower(String cprNo, String name, String bType, int year){
		//initialise name and year to parameters aName and newYear
		super(cprNo, name, bType, year);
        }

        ChildBorrower(String cprNo, String name, String bType, int year, 
                      String sex, Borrower parent)
        {	//calls super constructor and initialise a parent;
		super(cprNo, name, bType, year);
		this.sex = sex;
                this.parent = parent;
	}

	public AdultBorrower getParent ( )  {
		return (AdultBorrower) parent;
	}

	public void setParent (Borrower aParent)  {
		parent = aParent;
	}

	public String toString () {
		return (super.toString() + "\n" + "Child sex: "+ sex + "\n" + "Parent information: " + "\n" +
				parent.toString() );
		}

}// ChildBorrower

